;;;; @(#)$Id: config.scm,v 1.3 1997/05/12 07:21:25 qfwfq Exp $
; $Log: config.scm,v $
; Revision 1.3  1997/05/12 07:21:25  qfwfq
; version 0.31 - some enhancements on error handling etc.
;
; Revision 1.2  1997/04/26 13:29:11  qfwfq
; Version 0.30 - hygienic macro system with syntax-case
;
; Revision 1.1  1996/10/10 08:27:09  qfwfq
; Ported to Win32 environment.
;

; character used for separate diractory names and file name
(define-syntax cm-path-separate-char (syntax-rules () ((_) #\/)))
;(define-syntax cm-path-separate-char (syntax-rules () ((_) #\\)))

; character used for separate directory lists in search paths
(define-syntax cm-list-separate-char (syntax-rules () ((_) #\:)))
;(define-syntax cm-list-separate-char (syntax-rules () ((_) #\;)))

; C compile command
(define-syntax cc-command-str (syntax-rules () ((_) "gcc -O2 -m486")))
;(define-syntax cc-command-str (syntax-rules () ((_) "bcc32 -k- -v- -R- -O2 -w- -4 -DWIN32")))

; expression to make C compile command
(define-syntax cm-cc-command
  (syntax-rules ()
    ((_ libdir)
     (string-append (cc-command-str) (if libdir (string-append " -I" libdir) "") " -c"))))

; command line for C compile
(define-syntax cm-cc-line
  (syntax-rules ()
    ((_ cmd input) (string-append cmd " " input))))

; link command
(define-syntax ld-command-str (syntax-rules () ((_) "gcc")))
;(define-syntax ld-command-str (syntax-rules () ((_) "bcc32 -l /Tpe/ap")))

; expression to make link command
(define-syntax cm-ld-command
  (syntax-rules ()
    ((_ libdir)
     (if libdir (string-append (ld-command-str) " -L" libdir) (ld-command-str)))))

; link library
(define-syntax ld-lib-str (syntax-rules () ((_) "-lrhzscm -lrhzpi -lrhizome -lm")))
;(define-syntax ld-lib-str (syntax-rules () ((_) "-lrhzscm -lrhzpi -lrhizome -lkernel32 -lm")))
;(define-syntax ld-lib-str (syntax-rules () ((_) "rhzscm.lib rhzpi.lib rhizome.lib")))

; expression to make library option string
(define-syntax cm-ld-lib
  (syntax-rules ()
    ((_ libdir) (ld-lib-str))))

;; command line for link
; option to specify executable name
(define-syntax output-option-str (syntax-rules () ((_) " -o ")))
;(define-syntax output-option-str (syntax-rules () ((_) " -e")))

; add executable name option
(define-syntax cm-add-output-option
  (syntax-rules ()
    ((_ result out)
     (string-append result (output-option-str) out))))

; suffix for object file
(define-syntax obj-suffix-str (syntax-rules () ((_) ".o")))
;(define-syntax obj-suffix-str (syntax-rules () ((_) ".obj")))

; add C source module
(define-syntax cm-add-module
  (syntax-rules ()
    ((_ result module)
     (string-append result " " (rp:basename module ".c") (obj-suffix-str)))))

; value of system to exit status
(define-syntax cm-exit-status (syntax-rules () ((_ s) (quotient s 256))))
;(define-syntax cm-exit-status (syntax-rules () ((_ s) s)))

; name of environment variable pointing library directory
(define-syntax cm-lib-environment-var (syntax-rules () ((_) "RHIZOME_LIB")))

; name of environment variable specifying macro search path
(define-syntax cm-macro-path-var (syntax-rules () ((_) "RHIZOME_MACRO_PATH")))

; SIGINT signal number
(define-syntax cm-sigint-no (syntax-rules () ((_) 2)))
